[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 1. Introduction

Libavfilter is the filtering API of FFmpeg. It is the substitute of the now deprecated 'vhooks' and started as a Google Summer of Code project.

Integrating libavfilter into the main FFmpeg repository is a work in progress. If you wish to try the unfinished development code of libavfilter then check it out from the libavfilter repository into some directory of your choice by:

       svn checkout svn://svn.ffmpeg.org/soc/libavfilter

And then read the README file in the top directory to learn how to integrate it into ffmpeg and ffplay.

But note that there may still be serious bugs in the code and its API and ABI should not be considered stable yet!

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 2. Tutorial

In libavfilter, it is possible for filters to have multiple inputs and multiple outputs. To illustrate the sorts of things that are possible, we can use a complex filter graph. For example, the following one:

    input --> split --> fifo -----------------------> overlay --> output
                |                                        ^
                |                                        |
                +------> fifo --> crop --> vflip --------+

splits the stream in two streams, sends one stream through the crop filter and the vflip filter before merging it back with the other stream by overlaying it on top. You can use the following command to achieve this:

    ./ffmpeg -i in.avi -s 240x320 -vf "[in] split [T1], fifo, [T2] overlay= 0:240 [out]; [T1] fifo, crop=0:0:-1:240, vflip [T2]

where input_video.avi has a vertical resolution of 480 pixels. The result will be that in output the top half of the video is mirrored onto the bottom half.

Video filters are loaded using the -vf option passed to ffmpeg or to ffplay. Filters in the same linear chain are separated by commas. In our example, split, fifo, overlay are in one linear chain, and fifo, crop, vflip are in another. The points where the linear chains join are labeled by names enclosed in square brackets. In our example, that is [T1] and [T2]. The magic labels [in] and [out] are the points where video is input and output.

Some filters take in input a list of parameters: they are specified after the filter name and an equal sign, and are separated each other by a semicolon.

There exist so-called source filters that do not have a video input, and we expect in the future some sink filters that will not have video output.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 3. graph2dot

The ‘`graph2dot`’ program included in the FFmpeg ‘`tools`’ directory can be used to parse a filter graph description and issue a corresponding textual representation in the dot language.

Invoke the command:

    graph2dot -h

to see how to use ‘`graph2dot`’.

You can then pass the dot description to the ‘`dot`’ program (from the graphviz suite of programs) and obtain a graphical representation of the filter graph.

For example the sequence of commands:

    echo GRAPH_DESCRIPTION | \
    tools/graph2dot -o graph.tmp && \
    dot -Tpng graph.tmp -o graph.png && \
    display graph.png

can be used to create and display an image representing the graph described by the GRAPH_DESCRIPTION string.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 4. Audio Filters

When you configure your FFmpeg build, you can disable any of the existing filters using –disable-filters. The configure output will show the audio filters included in your build.

Below is a description of the currently available audio filters.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 4.1 anull

Pass the audio source unchanged to the output.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 5. Audio Sources

Below is a description of the currently available audio sources.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 5.1 anullsrc

Null audio source, never return audio frames. It is mainly useful as a template and to be employed in analysis / debugging tools.

It accepts as optional parameter a string of the form sample_rate:channel_layout.

sample_rate specify the sample rate, and defaults to 44100.

channel_layout specify the channel layout, and can be either an integer or a string representing a channel layout. The default value of channel_layout is 3, which corresponds to CH_LAYOUT_STEREO.

Check the channel_layout_map definition in ‘`libavcodec/audioconvert.c`’ for the mapping between strings and channel layout values.

Follow some examples:

    #  set the sample rate to 48000 Hz and the channel layout to CH_LAYOUT_MONO.
    anullsrc=48000:4

    # same as
    anullsrc=48000:mono

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 6. Audio Sinks

Below is a description of the currently available audio sinks.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.1 anullsink

Null audio sink, do absolutely nothing with the input audio. It is mainly useful as a template and to be employed in analysis / debugging tools.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 7. Video Filters

When you configure your FFmpeg build, you can disable any of the existing filters using –disable-filters. The configure output will show the video filters included in your build.

Below is a description of the currently available video filters.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.1 blackframe

Detect frames that are (almost) completely black. Can be useful to detect chapter transitions or commercials. Output lines consist of the frame number of the detected frame, the percentage of blackness, the position in the file if known or -1 and the timestamp in seconds.

In order to display the output lines, you need to set the loglevel at least to the AV_LOG_INFO value.

The filter accepts the syntax:

    blackframe[=amount:[threshold]]

amount is the percentage of the pixels that have to be below the threshold, and defaults to 98.

threshold is the threshold below which a pixel value is considered black, and defaults to 32.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.2 crop

Crop the input video to out_w:out_h:x:y.

The parameters are expressions containing the following constants:

‘`E, PI, PHI`’

  the corresponding mathematical approximated values for e (euler number), pi (greek PI), PHI (golden ratio)

‘`x, y`’

  the computed values for x and y. They are evaluated for each new frame.

‘`in_w, in_h`’

  the input width and heigth

‘`iw, ih`’

  same as in_w and in_h

‘`out_w, out_h`’

  the output (cropped) width and heigth

‘`ow, oh`’

  same as out_w and out_h

‘`n`’

  the number of input frame, starting from 0

‘`pos`’

  the position in the file of the input frame, NAN if unknown

‘`t`’

  timestamp expressed in seconds, NAN if the input timestamp is unknown

The out_w and out_h parameters specify the expressions for the width and height of the output (cropped) video. They are evaluated just at the configuration of the filter.

The default value of out_w is "in_w", and the default value of out_h is "in_h".

The expression for out_w may depend on the value of out_h, and the expression for out_h may depend on out_w, but they cannot depend on x and y, as x and y are evaluated after out_w and out_h.

The x and y parameters specify the expressions for the position of the top-left corner of the output (non-cropped) area. They are evaluated for each frame. If the evaluated value is not valid, it is approximated to the nearest valid value.

The default value of x is "(in_w-out_w)/2", and the default value for y is "(in_h-out_h)/2", which set the cropped area at the center of the input image.

The expression for x may depend on y, and the expression for y may depend on x.

Follow some examples:

    # crop the central input area with size 100x100
    crop=100:100

    # crop the central input area with size 2/3 of the input video
    "crop=2/3*in_w:2/3*in_h"

    # crop the input video central square
    crop=in_h

    # delimit the rectangle with the top-left corner placed at position
    # 100:100 and the right-bottom corner corresponding to the right-bottom
    # corner of the input image.
    crop=in_w-100:in_h-100:100:100

    # crop 10 pixels from the lefth and right borders, and 20 pixels from
    # the top and bottom borders
    "crop=in_w-2*10:in_h-2*20"

    # keep only the bottom right quarter of the input image
    "crop=in_w/2:in_h/2:in_w/2:in_h/2"

    # crop height for getting Greek harmony
    "crop=in_w:1/PHI*in_w"

    # trembling effect
    "crop=in_w/2:in_h/2:(in_w-out_w)/2+((in_w-out_w)/2)*sin(n/10):(in_h-out_h)/2 +((in_h-out_h)/2)*sin(n/7)"

    # erratic camera effect depending on timestamp and position
    "crop=in_w/2:in_h/2:(in_w-out_w)/2+((in_w-out_w)/2)*sin(t*10):(in_h-out_h)/2 +((in_h-out_h)/2)*sin(t*13)"

    # set x depending on the value of y
    "crop=in_w/2:in_h/2:y:10+10*sin(n/10)"

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.3 fifo

Buffer input images and send them when they are requested.

This filter is mainly useful when auto-inserted by the libavfilter framework.

The filter does not take parameters.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.4 format

Convert the input video to one of the specified pixel formats. Libavfilter will try to pick one that is supported for the input to the next filter.

The filter accepts a list of pixel format names, separated by ":", for example "yuv420p:monow:rgb24".

The following command:

    ./ffmpeg -i in.avi -vf "format=yuv420p" out.avi

will convert the input video to the format "yuv420p".

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.5 frei0r

Apply a frei0r effect to the input video.

To enable compilation of this filter you need to install the frei0r header and configure FFmpeg with –enable-frei0r.

The filter supports the syntax:

    filter_name:param1:param2:...:paramN

filter_name is the name to the frei0r effect to load. If the environment variable `FREI0R_PATH` is defined, the frei0r effect is searched in each one of the directories specified by the colon separated list in `FREIOR_PATH`, otherwise in the standard frei0r paths, which are in this order: ‘`HOME/.frei0r-1/lib/`’, ‘`/usr/local/lib/frei0r-1/`’, ‘`/usr/lib/frei0r-1/`’.

param1, param2, ... , paramN specify the parameters for the frei0r effect.

A frei0r effect parameter can be a boolean (whose values are specified with "y" and "n"), a double, a color (specified by the syntax R/G/B, R, G, and B being float numbers from 0.0 to 1.0) or by an `av_parse_color()` color description), a position (specified by the syntax X/Y, X and Y being float numbers) and a string.

The number and kind of parameters depend on the loaded effect. If an effect parameter is not specified the default value is set.

Some examples follow:

    # apply the distort0r effect, set the first two double parameters
    frei0r=distort0r:0.5:0.01

    # apply the colordistance effect, takes a color as first parameter
    frei0r=colordistance:0.2/0.3/0.4
    frei0r=colordistance:violet
    frei0r=colordistance:0x112233

    # apply the perspective effect, specify the top left and top right
    # image positions
    frei0r=perspective:0.2/0.2:0.8/0.2

For more information see: http://piksel.org/frei0r

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.6 hflip

Flip the input video horizontally.

For example to horizontally flip the video in input with ‘`ffmpeg`’:

    ffmpeg -i in.avi -vf "hflip" out.avi

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.7 noformat

Force libavfilter not to use any of the specified pixel formats for the input to the next filter.

The filter accepts a list of pixel format names, separated by ":", for example "yuv420p:monow:rgb24".

The following command:

    ./ffmpeg -i in.avi -vf "noformat=yuv420p, vflip" out.avi

will make libavfilter use a format different from "yuv420p" for the input to the vflip filter.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.8 null

Pass the video source unchanged to the output.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.9 ocv_smooth

Apply smooth transform using libopencv.

To enable this filter install libopencv library and headers and configure FFmpeg with –enable-libopencv.

The filter accepts the following parameters: type:param1:param2:param3:param4.

type is the type of smooth filter to apply, and can be one of the following values: "blur", "blur_no_scale", "median", "gaussian", "bilateral". The default value is "gaussian".

param1, param2, param3, and param4 are parameters whose meanings depend on smooth type. param1 and param2 accept integer positive values or 0, param3 and param4 accept float values.

The default value for param1 is 3, the default value for the other parameters is 0.

These parameters correspond to the parameters assigned to the libopencv function `cvSmooth`. Refer to the official libopencv documentation for the exact meaning of the parameters: http://opencv.willowgarage.com/documentation/c/image_filtering.html

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.10 pad

Add paddings to the input image, and places the original input at the given coordinates x, y.

It accepts the following parameters: width:height:x:y:color.

Follows the description of the accepted parameters.

‘`width, height`’

  Specify the size of the output image with the paddings added. If the value for width or height is 0, the corresponding input size is used for the output.

  The default value of width and height is 0.

‘`x, y`’

  Specify the offsets where to place the input image in the padded area with respect to the top/left border of the output image.

  The default value of x and y is 0.

‘`color`’

  Specify the color of the padded area, it can be the name of a color (case insensitive match) or a 0xRRGGBB[AA] sequence.

  The default value of color is "black".

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.11 pixdesctest

Pixel format descriptor test filter, mainly useful for internal testing. The output video should be equal to the input video.

For example:

    format=monow, pixdesctest

can be used to test the monowhite pixel format descriptor definition.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.12 scale

Scale the input video to width:height and/or convert the image format.

For example the command:

    ./ffmpeg -i in.avi -vf "scale=200:100" out.avi

will scale the input video to a size of 200x100.

If the input image format is different from the format requested by the next filter, the scale filter will convert the input to the requested format.

If the value for width or height is 0, the respective input size is used for the output.

If the value for width or height is -1, the scale filter will use, for the respective output size, a value that maintains the aspect ratio of the input image.

The default value of width and height is 0.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.13 slicify

Pass the images of input video on to next video filter as multiple slices.

    ./ffmpeg -i in.avi -vf "slicify=32" out.avi

The filter accepts the slice height as parameter. If the parameter is not specified it will use the default value of 16.

Adding this in the beginning of filter chains should make filtering faster due to better use of the memory cache.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.14 unsharp

Sharpen or blur the input video.

It accepts the following parameters: luma_msize_x:luma_msize_y:luma_amount:chroma_msize_x:chroma_msize_y:chroma_amount

Negative values for the amount will blur the input video, while positive values will sharpen. All parameters are optional and default to the equivalent of the string '5:5:1.0:0:0:0.0'.

‘`luma_msize_x`’

  Set the luma matrix horizontal size. It can be an integer between 3 and 13, default value is 5.

‘`luma_msize_y`’

  Set the luma matrix vertical size. It can be an integer between 3 and 13, default value is 5.

‘`luma_amount`’

  Set the luma effect strength. It can be a float number between -2.0 and 5.0, default value is 1.0.

‘`chroma_msize_x`’

  Set the chroma matrix horizontal size. It can be an integer between 3 and 13, default value is 0.

‘`chroma_msize_y`’

  Set the chroma matrix vertical size. It can be an integer between 3 and 13, default value is 0.

‘`luma_amount`’

  Set the chroma effect strength. It can be a float number between -2.0 and 5.0, default value is 0.0.

    # Strong luma sharpen effect parameters
    unsharp=7:7:2.5

    # Strong blur of both luma and chroma parameters
    unsharp=7:7:-2:7:7:-2

    # Use the default values with ffmpeg
    ./ffmpeg -i in.avi -vf "unsharp" out.mp4

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.15 vflip

Flip the input video vertically.

    ./ffmpeg -i in.avi -vf "vflip" out.avi

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 7.16 yadif

yadif is "yet another deinterlacing filter".

It accepts the syntax:

    yadif=[mode[:parity]]

‘`mode`’

  Specify the interlacing mode to adopt, accepts one of the following values.

  0: Output 1 frame for each frame.

  1: Output 1 frame for each field.

  2: Like 0 but skips spatial interlacing check.

  3: Like 1 but skips spatial interlacing check.

  Default value is 0.

‘`parity`’

  0 if is bottom field first, 1 if the interlaced video is top field first, -1 to enable automatic detection.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 8. Video Sources

Below is a description of the currently available video sources.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.1 buffer

Buffer video frames, and make them available to the filter chain.

This source is mainly intended for a programmatic use, in particular through the interface defined in ‘`libavfilter/vsrc_buffer.h`’.

It accepts the following parameters: width:height:pix_fmt_string

All the parameters need to be explicitely defined.

Follows the list of the accepted parameters.

‘`width, height`’

  Specify the width and height of the buffered video frames.

‘`pix_fmt_string`’

  A string representing the pixel format of the buffered video frames. It may be a number corresponding to a pixel format, or a pixel format name.

For example:

    buffer=320:240:yuv410p

will instruct the source to accept video frames with size 320x240 and with format "yuv410p". Since the pixel format with name "yuv410p" corresponds to the number 6 (check the enum PixelFormat definition in ‘`libavutil/pixfmt.h`’), this example corresponds to:

    buffer=320:240:6

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.2 color

Provide an uniformly colored input.

It accepts the following parameters: color:frame_size:frame_rate

Follows the description of the accepted parameters.

‘`color`’

  Specify the color of the source. It can be the name of a color (case insensitive match) or a 0xRRGGBB[AA] sequence, possibly followed by an alpha specifier. The default value is "black".

‘`frame_size`’

  Specify the size of the sourced video, it may be a string of the form widthxheigth, or the name of a size abbreviation. The default value is "320x240".

‘`frame_rate`’

  Specify the frame rate of the sourced video, as the number of frames generated per second. It has to be a string in the format frame_rate_num/frame_rate_den, an integer number, a float number or a valid video frame rate abbreviation. The default value is "25".

For example the following graph description will generate a red source with an opacity of 0.2, with size "qcif" and a frame rate of 10 frames per second, which will be overlayed over the source connected to the pad with identifier "in".

    "color=red@0.2:qcif:10 [color]; [in][color] overlay [out]"

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 8.3 nullsrc

Null video source, never return images. It is mainly useful as a template and to be employed in analysis / debugging tools.

It accepts as optional parameter a string of the form width:height, where width and height specify the size of the configured source.

The default values of width and height are respectively 352 and 288 (corresponding to the CIF size format).

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 9. Video Sinks

Below is a description of the currently available video sinks.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 9.1 nullsink

Null video sink, do absolutely nothing with the input video. It is mainly useful as a template and to be employed in analysis / debugging tools.

[Top] | [Contents] | [Index] | [ ? ]

# About This Document

This document was generated on November, 22 2010 using texi2html 1.78.

The buttons in the navigation panels have the following meaning:

Button | Name | Go to | From 1.2.3 go to
--- | --- | --- | ---
[ < ] | Back | Previous section in reading order | 1.2.2
[ > ] | Forward | Next section in reading order | 1.2.4
[ << ] | FastBack | Beginning of this chapter or previous chapter | 1
[ Up ] | Up | Up section | 1.2
[ >> ] | FastForward | Next chapter | 2
[Top] | Top | Cover (top) of document |
[Contents] | Contents | Table of contents |
[Index] | Index | Index |
[ ? ] | About | About (help) |

where the Example assumes that the current position is at Subsubsection One-Two-Three of a document of the following structure:

- 1. Section One
  - 1.1 Subsection One-One
    - ...
  - 1.2 Subsection One-Two
    - 1.2.1 Subsubsection One-Two-One
    - 1.2.2 Subsubsection One-Two-Two
    - 1.2.3 Subsubsection One-Two-Three <== Current Position
    - 1.2.4 Subsubsection One-Two-Four
  - 1.3 Subsection One-Three
    - ...
  - 1.4 Subsection One-Four

This document was generated on November, 22 2010 using texi2html 1.78.